import B from "node:path";
import { ESLintUtils as pe, ASTUtils as _ } from "@typescript-eslint/utils";
import { minimatch as $ } from "minimatch";
import ue from "natural-compare-lite";
import { builtinModules as de } from "node:module";
let O = pe.RuleCreator(
  (t) => `https://eslint-plugin-perfectionist.azat.io/rules/${t}`
), x = (t, n) => {
  for (let s = 0, l = t.length; s < l; s++) {
    let r = t[s];
    if (n.group === r || Array.isArray(r) && typeof n.group == "string" && r.includes(n.group))
      return s;
  }
  return t.length;
}, v = (t) => {
  let [n, s] = t;
  return s - n;
}, I = (t) => t > 0;
var p = /* @__PURE__ */ ((t) => (t.alphabetical = "alphabetical", t["line-length"] = "line-length", t.natural = "natural", t))(p || {}), g = /* @__PURE__ */ ((t) => (t.desc = "desc", t.asc = "asc", t))(g || {});
let G = (t) => {
  let n, s = (r) => {
    !n && t.flat().includes(r) && (n = r);
  };
  return {
    getGroup: () => n ?? "unknown",
    setCustomGroups: (r, e) => {
      if (r)
        for (let [a, i] of Object.entries(r))
          Array.isArray(i) && i.some(
            (o) => $(e, o, {
              nocomment: !0
            })
          ) && s(a), typeof i == "string" && $(e, i, {
            nocomment: !0
          }) && s(a);
    },
    defineGroup: s
  };
}, S = (t, n, s) => {
  var a, i;
  if ((a = n.dependencies) != null && a.includes(t.name))
    return -1;
  if ((i = t.dependencies) != null && i.includes(n.name))
    return 1;
  let l = s.order === "asc" ? 1 : -1, r, e = (o) => s["ignore-case"] ? o.toLowerCase() : o;
  return s.type === p.alphabetical ? r = (o, u) => e(o.name).localeCompare(e(u.name)) : s.type === p.natural ? r = (o, u) => ue(e(o.name), e(u.name)) : r = (o, u) => {
    let y = o.size, m = u.size, c = s["max-line-length"];
    if (c) {
      let d = (f, b) => f > c && b.hasMultipleImportDeclarations;
      d(y, o) && (y = o.name.length + 10), d(m, u) && (m = u.name.length + 10);
    }
    return y - m;
  }, l * r(t, n);
}, w = (t, n) => [...t].sort((s, l) => S(s, l, n)), ce = (t, n) => {
  let s = n.getTokenAfter(t, {
    filter: ({ value: l, type: r }) => !(r === "Punctuator" && [",", ";"].includes(l)),
    includeComments: !0
  });
  return ((s == null ? void 0 : s.type) === "Block" || (s == null ? void 0 : s.type) === "Line") && t.loc.end.line === s.loc.end.line ? s : null;
}, ie = (t, n) => Array.isArray(t) && t.some(
  (s) => $(n.trim(), s, {
    nocomment: !0
  })
) || typeof t == "string" && $(n.trim(), t, {
  nocomment: !0
}) || t === !0, V = (t, n) => {
  let [s, l] = n.getTokensBefore(t, {
    filter: ({ value: r, type: e }) => !(e === "Punctuator" && [",", ";"].includes(r)),
    includeComments: !0,
    count: 2
  });
  return ((l == null ? void 0 : l.type) === "Block" || (l == null ? void 0 : l.type) === "Line") && t.loc.start.line - l.loc.end.line <= 1 && (s == null ? void 0 : s.loc.end.line) !== l.loc.start.line ? l : null;
}, T = (t, n, s) => {
  var i;
  let l = t.range.at(0), r = t.range.at(1), e = n.text.slice(l, r);
  if (_.isParenthesized(t, n)) {
    let o = n.getTokenBefore(
      t,
      _.isOpeningParenToken
    ), u = n.getTokenAfter(
      t,
      _.isClosingParenToken
    );
    l = o.range.at(0), r = u.range.at(1);
  }
  let a = V(t, n);
  if (e.endsWith(";") || e.endsWith(",")) {
    let o = n.getTokensAfter(t, {
      includeComments: !0,
      count: 2
    });
    t.loc.start.line === ((i = o.at(1)) == null ? void 0 : i.loc.start.line) && (r -= 1);
  }
  return a && !ie(
    (s == null ? void 0 : s.partitionComment) ?? !1,
    a.value
  ) && (l = a.range.at(0)), [l, r];
}, L = (t, n, s, l, r) => {
  var i, o;
  let e = [], a = ((i = n.at(0)) == null ? void 0 : i.node.loc.start.line) === ((o = n.at(-1)) == null ? void 0 : o.node.loc.end.line);
  for (let u = 0, y = n.length; u < y; u++) {
    let { node: m } = n.at(u);
    e.push(
      t.replaceTextRange(
        T(m, l, r),
        l.text.slice(
          ...T(s.at(u).node, l, r)
        )
      )
    );
    let c = ce(s.at(u).node, l);
    if (c && !a) {
      let f = [
        l.getTokenBefore(c).range.at(1),
        c.range.at(1)
      ];
      e.push(t.replaceTextRange(f, ""));
      let b = l.getTokenAfter(m);
      e.push(
        t.insertTextAfter(
          (b == null ? void 0 : b.loc.end.line) === m.loc.end.line ? b : m,
          l.text.slice(...f)
        )
      );
    }
  }
  return e;
}, j = (t = {}, n) => Object.assign(n, t), k = (t, n) => {
  if (t.length > 1)
    for (let s = 1; s < t.length; s++) {
      let l = t.at(s - 1), r = t.at(s);
      l && r && n(l, r, s - 1);
    }
};
const J = "sort-svelte-attributes", fe = O({
  name: J,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted Svelte attributes"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          "custom-groups": {
            type: "object"
          },
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [g.asc, g.desc],
            default: g.asc,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          },
          groups: {
            type: "array"
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedSvelteAttributesOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: g.asc
    }
  ],
  create: (t) => B.extname(t.filename) !== ".svelte" ? {} : {
    SvelteStartTag: (n) => {
      if (n.attributes.length > 1) {
        let s = j(t.options.at(0), {
          type: p.alphabetical,
          order: g.asc,
          "ignore-case": !1,
          "custom-groups": {},
          groups: []
        }), l = n.attributes.reduce(
          (r, e) => {
            if (e.type === "SvelteSpreadAttribute")
              return r.push([]), r;
            let a, { getGroup: i, defineGroup: o, setCustomGroups: u } = G(
              s.groups
            );
            return e.key.type === "SvelteSpecialDirectiveKey" ? a = t.sourceCode.text.slice(...e.key.range) : typeof e.key.name == "string" ? { name: a } = e.key : a = t.sourceCode.text.slice(...e.key.range), u(s["custom-groups"], a), e.type === "SvelteShorthandAttribute" && (o("svelte-shorthand"), o("shorthand")), (!("value" in e) || Array.isArray(e.value) && !e.value.at(0)) && o("shorthand"), e.loc.start.line !== e.loc.end.line && o("multiline"), r.at(-1).push({
              size: v(e.range),
              node: e,
              group: i(),
              name: a
            }), r;
          },
          [[]]
        );
        for (let r of l)
          k(r, (e, a) => {
            let i = x(s.groups, e), o = x(s.groups, a);
            (i > o || i === o && I(S(e, a, s))) && t.report({
              messageId: "unexpectedSvelteAttributesOrder",
              data: {
                left: e.name,
                right: a.name
              },
              node: a.node,
              fix: (u) => {
                let y = {};
                for (let c of r) {
                  let d = x(s.groups, c);
                  d in y ? y[d] = w(
                    [...y[d], c],
                    s
                  ) : y[d] = [c];
                }
                let m = [];
                for (let c of Object.keys(y).sort(
                  (d, f) => Number(d) - Number(f)
                ))
                  m.push(...w(y[c], s));
                return L(
                  u,
                  r,
                  m,
                  t.sourceCode
                );
              }
            });
          });
      }
    }
  }
}), X = "sort-astro-attributes", ge = O({
  name: X,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted Astro attributes"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          "custom-groups": {
            type: "object"
          },
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [g.asc, g.desc],
            default: g.asc,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          },
          groups: {
            type: "array"
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedAstroAttributesOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: g.asc
    }
  ],
  // @ts-ignore
  create: (t) => B.extname(t.filename) !== ".astro" ? {} : {
    JSXElement: (n) => {
      let { attributes: s } = n.openingElement;
      if (s.length > 1) {
        let l = j(t.options.at(0), {
          type: p.alphabetical,
          order: g.asc,
          "ignore-case": !1,
          "custom-groups": {},
          groups: []
        }), r = s.reduce(
          (e, a) => {
            if (a.type === "JSXSpreadAttribute")
              return e.push([]), e;
            let i = typeof a.name.name == "string" ? a.name.name : t.sourceCode.text.slice(...a.name.range), { getGroup: o, defineGroup: u, setCustomGroups: y } = G(
              l.groups
            );
            return y(l["custom-groups"], i), a.type === "AstroShorthandAttribute" && (u("astro-shorthand"), u("shorthand")), a.value === null && u("shorthand"), a.loc.start.line !== a.loc.end.line && u("multiline"), e.at(-1).push({
              size: v(a.range),
              node: a,
              group: o(),
              name: i
            }), e;
          },
          [[]]
        );
        for (let e of r)
          k(e, (a, i) => {
            let o = x(l.groups, a), u = x(l.groups, i);
            (o > u || o === u && I(S(a, i, l))) && t.report({
              messageId: "unexpectedAstroAttributesOrder",
              data: {
                left: a.name,
                right: i.name
              },
              node: i.node,
              fix: (y) => {
                let m = {};
                for (let d of e) {
                  let f = x(l.groups, d);
                  f in m ? m[f] = w(
                    [...m[f], d],
                    l
                  ) : m[f] = [d];
                }
                let c = [];
                for (let d of Object.keys(m).sort(
                  (f, b) => Number(f) - Number(b)
                ))
                  c.push(...w(m[d], l));
                return L(
                  y,
                  e,
                  c,
                  t.sourceCode
                );
              }
            });
          });
      }
    }
  }
});
let A = (t) => t.replaceAll(/\s\s+/g, " ").trim();
const q = "sort-array-includes", ye = O({
  name: q,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted arrays before include method"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [g.asc, g.desc],
            default: g.asc,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          },
          "spread-last": {
            type: "boolean",
            default: !1
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedArrayIncludesOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: g.asc
    }
  ],
  create: (t) => ({
    MemberExpression: (n) => {
      if ((n.object.type === "ArrayExpression" || n.object.type === "NewExpression") && n.property.type === "Identifier" && n.property.name === "includes") {
        let s = n.object.type === "ArrayExpression" ? n.object.elements : n.object.arguments;
        if (s.length > 1) {
          let l = j(t.options.at(0), {
            type: p.alphabetical,
            order: g.asc,
            "ignore-case": !1,
            "spread-last": !1
          }), r = s.reduce(
            (e, a) => (a !== null && e.at(0).push({
              name: a.type === "Literal" ? `${a.value}` : t.sourceCode.text.slice(...a.range),
              size: v(a.range),
              type: a.type,
              node: a
            }), e),
            [[], []]
          ).flat();
          k(r, (e, a) => {
            let i;
            l["spread-last"] && e.node.type === "Literal" && a.node.type === "SpreadElement" ? i = !1 : l["spread-last"] && e.node.type === "SpreadElement" && a.node.type === "Literal" ? i = !0 : i = I(S(e, a, l)), i && t.report({
              messageId: "unexpectedArrayIncludesOrder",
              data: {
                left: A(e.name),
                right: A(a.name)
              },
              node: a.node,
              fix: (o) => {
                let u = w(r, l);
                if (l["spread-last"])
                  for (let y = 0, m = u.length; y < m; y++)
                    u.at(y).node.type === "SpreadElement" && u.push(u.splice(y, 1).at(0));
                return L(
                  o,
                  r,
                  u,
                  t.sourceCode
                );
              }
            });
          });
        }
      }
    }
  })
}), K = "sort-vue-attributes", me = O({
  name: K,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted Vue attributes"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          "custom-groups": {
            type: "object"
          },
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [g.asc, g.desc],
            default: g.asc,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          },
          groups: {
            type: "array",
            default: []
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedVueAttributesOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: g.asc
    }
  ],
  create: (t) => {
    if (B.extname(t.filename) !== ".vue")
      return {};
    if (!("defineTemplateBodyVisitor" in t.sourceCode.parserServices))
      return {};
    let { defineTemplateBodyVisitor: n } = t.sourceCode.parserServices;
    return n({
      VStartTag: (s) => {
        if (s.attributes.length > 1) {
          let l = j(t.options.at(0), {
            type: p.alphabetical,
            order: g.asc,
            "ignore-case": !1,
            "custom-groups": {},
            groups: []
          }), r = s.attributes.reduce(
            (e, a) => {
              if (a.key.type === "VDirectiveKey" && a.key.name.rawName === "bind")
                return e.push([]), e;
              let i, { getGroup: o, defineGroup: u, setCustomGroups: y } = G(
                l.groups
              );
              return typeof a.key.name == "string" && a.key.type !== "VDirectiveKey" ? i = a.key.rawName : i = t.sourceCode.text.slice(...a.key.range), y(l["custom-groups"], i), a.value === null && u("shorthand"), a.loc.start.line !== a.loc.end.line && u("multiline"), e.at(-1).push({
                size: v(a.range),
                node: a,
                group: o(),
                name: i
              }), e;
            },
            [[]]
          );
          for (let e of r)
            k(e, (a, i) => {
              let o = x(l.groups, a), u = x(l.groups, i);
              (o > u || o === u && I(S(a, i, l))) && t.report({
                messageId: "unexpectedVueAttributesOrder",
                data: {
                  left: a.name,
                  right: i.name
                },
                node: i.node,
                fix: (y) => {
                  let m = {};
                  for (let d of e) {
                    let f = x(l.groups, d);
                    f in m ? m[f] = w(
                      [...m[f], d],
                      l
                    ) : m[f] = [d];
                  }
                  let c = [];
                  for (let d of Object.keys(m).sort(
                    (f, b) => Number(f) - Number(b)
                  ))
                    c.push(...w(m[d], l));
                  return L(
                    y,
                    e,
                    c,
                    t.sourceCode
                  );
                }
              });
            });
        }
      }
    });
  }
}), H = "sort-named-exports", he = O({
  name: H,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted named exports"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [g.asc, g.desc],
            default: g.asc,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedNamedExportsOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: g.asc
    }
  ],
  create: (t) => ({
    ExportNamedDeclaration: (n) => {
      if (n.specifiers.length > 1) {
        let s = j(t.options.at(0), {
          type: p.alphabetical,
          "ignore-case": !1,
          order: g.asc
        }), l = n.specifiers.map((r) => ({
          size: v(r.range),
          name: r.local.name,
          node: r
        }));
        k(l, (r, e) => {
          I(S(r, e, s)) && t.report({
            messageId: "unexpectedNamedExportsOrder",
            data: {
              left: r.name,
              right: e.name
            },
            node: e.node,
            fix: (a) => L(
              a,
              l,
              w(l, s),
              t.sourceCode
            )
          });
        });
      }
    }
  })
}), Q = "sort-named-imports", be = O({
  name: Q,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted named imports"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [g.asc, g.desc],
            default: g.asc,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          },
          "ignore-alias": {
            type: "boolean",
            default: !1
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedNamedImportsOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: g.asc
    }
  ],
  create: (t) => ({
    ImportDeclaration: (n) => {
      let s = n.specifiers.filter(
        ({ type: l }) => l === "ImportSpecifier"
      );
      if (s.length > 1) {
        let l = j(t.options.at(0), {
          type: p.alphabetical,
          "ignore-alias": !0,
          "ignore-case": !1,
          order: g.asc
        }), r = s.map((e) => {
          let { name: a } = e.local;
          return l["ignore-alias"] && e.type === "ImportSpecifier" && ({ name: a } = e.imported), {
            size: v(e.range),
            node: e,
            name: a
          };
        });
        k(r, (e, a) => {
          I(S(e, a, l)) && t.report({
            messageId: "unexpectedNamedImportsOrder",
            data: {
              left: e.name,
              right: a.name
            },
            node: a.node,
            fix: (i) => L(
              i,
              r,
              w(r, l),
              t.sourceCode
            )
          });
        });
      }
    }
  })
});
let z = (t, n, s) => t.lines.slice(
  n.node.loc.end.line,
  s.node.loc.start.line - 1
).filter((r) => !r.trim().length).length;
const Y = "sort-object-types", xe = O({
  name: Y,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted object types"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          "custom-groups": {
            type: "object"
          },
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [g.asc, g.desc],
            default: g.asc,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          },
          groups: {
            type: "array",
            default: []
          },
          "partition-by-new-line": {
            type: "boolean",
            default: !1
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedObjectTypesOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: g.asc
    }
  ],
  create: (t) => ({
    TSTypeLiteral: (n) => {
      if (n.members.length > 1) {
        let s = j(t.options.at(0), {
          "partition-by-new-line": !1,
          type: p.alphabetical,
          "ignore-case": !1,
          order: g.asc,
          "custom-groups": {},
          groups: []
        }), l = n.members.reduce(
          (r, e) => {
            var E, h, C, N;
            let a, i = t.sourceCode.text.slice(
              e.range.at(0),
              e.range.at(1)
            ), o = (E = r.at(-1)) == null ? void 0 : E.at(-1), { getGroup: u, defineGroup: y, setCustomGroups: m } = G(
              s.groups
            ), c = (P) => P.replace(/(,|;)$/, "");
            if (e.type === "TSPropertySignature")
              e.key.type === "Identifier" ? { name: a } = e.key : e.key.type === "Literal" ? a = `${e.key.value}` : a = t.sourceCode.text.slice(
                e.range.at(0),
                (h = e.typeAnnotation) == null ? void 0 : h.range.at(0)
              );
            else if (e.type === "TSIndexSignature") {
              let P = ((C = e.typeAnnotation) == null ? void 0 : C.range.at(0)) ?? e.range.at(1);
              a = c(
                t.sourceCode.text.slice(e.range.at(0), P)
              );
            } else
              a = c(
                t.sourceCode.text.slice(
                  e.range.at(0),
                  e.range.at(1)
                )
              );
            m(s["custom-groups"], a), e.loc.start.line !== e.loc.end.line && y("multiline");
            let f = i.endsWith(";") || i.endsWith(",") ? 1 : 0, b = {
              size: v(e.range) - f,
              node: e,
              name: a
            };
            return s["partition-by-new-line"] && o && z(t.sourceCode, o, b) && r.push([]), (N = r.at(-1)) == null || N.push({
              ...b,
              group: u()
            }), r;
          },
          [[]]
        );
        for (let r of l)
          k(r, (e, a) => {
            let i = x(s.groups, e), o = x(s.groups, a);
            (i > o || i === o && I(S(e, a, s))) && t.report({
              messageId: "unexpectedObjectTypesOrder",
              data: {
                left: A(e.name),
                right: A(a.name)
              },
              node: a.node,
              fix: (u) => {
                let y = {};
                for (let c of r) {
                  let d = x(s.groups, c);
                  d in y ? y[d] = w(
                    [...y[d], c],
                    s
                  ) : y[d] = [c];
                }
                let m = [];
                for (let c of Object.keys(y).sort(
                  (d, f) => Number(d) - Number(f)
                ))
                  m.push(...w(y[c], s));
                return L(
                  u,
                  r,
                  m,
                  t.sourceCode
                );
              }
            });
          });
      }
    }
  })
}), Z = "sort-union-types", Ee = O({
  name: Z,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted union types"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [g.asc, g.desc],
            default: g.asc,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          },
          "nullable-last": {
            type: "boolean",
            default: !1
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedUnionTypesOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: g.asc
    }
  ],
  create: (t) => ({
    TSUnionType: (n) => {
      let s = j(t.options.at(0), {
        type: p.alphabetical,
        "nullable-last": !1,
        "ignore-case": !1,
        order: g.asc
      }), l = n.types.map((r) => ({
        group: r.type === "TSNullKeyword" || r.type === "TSUndefinedKeyword" ? "nullable" : "unknown",
        name: t.sourceCode.text.slice(...r.range),
        size: v(r.range),
        node: r
      }));
      k(l, (r, e) => {
        let a = I(S(r, e, s));
        s["nullable-last"] && (r.group === "nullable" && e.group === "unknown" ? a = !0 : r.group === "unknown" && e.group === "nullable" && (a = !1)), a && t.report({
          messageId: "unexpectedUnionTypesOrder",
          data: {
            left: A(r.name),
            right: A(e.name)
          },
          node: e.node,
          fix: (i) => {
            let o = [];
            if (s["nullable-last"]) {
              let u = [], y = l.filter((m) => m.group === "nullable" ? (u.push(m), !1) : !0);
              o = [
                ...w(y, s),
                ...w(u, s)
              ];
            } else
              o = w(l, s);
            return L(i, l, o, t.sourceCode);
          }
        });
      });
    }
  })
}), F = "sort-interfaces", Ce = O({
  name: F,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted interface properties"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          "custom-groups": {
            type: "object"
          },
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [g.asc, g.desc],
            default: g.asc,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          },
          "ignore-pattern": {
            items: {
              type: "string"
            },
            type: "array"
          },
          groups: {
            type: "array",
            default: []
          },
          "partition-by-new-line": {
            type: "boolean",
            default: !1
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedInterfacePropertiesOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: g.asc
    }
  ],
  create: (t) => ({
    TSInterfaceDeclaration: (n) => {
      if (n.body.body.length > 1) {
        let s = j(t.options.at(0), {
          "partition-by-new-line": !1,
          type: p.alphabetical,
          "ignore-case": !1,
          order: g.asc,
          "ignore-pattern": [],
          "custom-groups": {},
          groups: []
        });
        if (!s["ignore-pattern"].some(
          (l) => $(n.id.name, l, {
            nocomment: !0
          })
        )) {
          let l = n.body.body.reduce(
            (r, e) => {
              var c, d, f, b;
              if (e.type === "TSCallSignatureDeclaration")
                return r.push([]), r;
              let a = (c = r.at(-1)) == null ? void 0 : c.at(-1), i, { getGroup: o, defineGroup: u, setCustomGroups: y } = G(
                s.groups
              );
              if (e.type === "TSPropertySignature")
                if (e.key.type === "Identifier")
                  ({ name: i } = e.key);
                else if (e.key.type === "Literal")
                  i = `${e.key.value}`;
                else {
                  let E = ((d = e.typeAnnotation) == null ? void 0 : d.range.at(0)) ?? e.range.at(1) - (e.optional ? 1 : 0);
                  i = t.sourceCode.text.slice(e.range.at(0), E);
                }
              else if (e.type === "TSIndexSignature") {
                let E = ((f = e.typeAnnotation) == null ? void 0 : f.range.at(0)) ?? e.range.at(1);
                i = t.sourceCode.text.slice(
                  e.range.at(0),
                  E
                );
              } else {
                let E = ((b = e.returnType) == null ? void 0 : b.range.at(0)) ?? e.range.at(1);
                i = t.sourceCode.text.slice(
                  e.range.at(0),
                  E
                );
              }
              let m = {
                size: v(e.range),
                node: e,
                name: i
              };
              return s["partition-by-new-line"] && a && z(
                t.sourceCode,
                a,
                m
              ) && r.push([]), y(s["custom-groups"], i), e.loc.start.line !== e.loc.end.line && u("multiline"), r.at(-1).push({
                ...m,
                group: o()
              }), r;
            },
            [[]]
          );
          for (let r of l)
            k(r, (e, a) => {
              let i = x(s.groups, e), o = x(s.groups, a);
              (i > o || i === o && I(S(e, a, s))) && t.report({
                messageId: "unexpectedInterfacePropertiesOrder",
                data: {
                  left: A(e.name),
                  right: A(a.name)
                },
                node: a.node,
                fix: (u) => {
                  let y = {};
                  for (let c of r) {
                    let d = x(s.groups, c);
                    d in y ? y[d] = w(
                      [...y[d], c],
                      s
                    ) : y[d] = [c];
                  }
                  let m = [];
                  for (let c of Object.keys(y).sort(
                    (d, f) => Number(d) - Number(f)
                  ))
                    m.push(...w(y[c], s));
                  return L(
                    u,
                    r,
                    m,
                    t.sourceCode
                  );
                }
              });
            });
        }
      }
    }
  })
}), ee = "sort-jsx-props", Ne = O({
  name: ee,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted JSX props"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          "custom-groups": {
            type: "object"
          },
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [g.asc, g.desc],
            default: g.asc,
            type: "string"
          },
          groups: {
            type: "array"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedJSXPropsOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: g.asc
    }
  ],
  create: (t) => [".svelte", ".astro", ".vue"].includes(B.extname(t.filename)) ? {} : {
    JSXElement: (n) => {
      if (n.openingElement.attributes.length > 1) {
        let s = j(t.options.at(0), {
          type: p.alphabetical,
          "ignore-case": !1,
          order: g.asc,
          "custom-groups": {},
          groups: []
        }), l = n.openingElement.attributes.reduce(
          (r, e) => {
            if (e.type === "JSXSpreadAttribute")
              return r.push([]), r;
            let a = e.name.type === "JSXNamespacedName" ? `${e.name.namespace.name}:${e.name.name.name}` : e.name.name, { getGroup: i, defineGroup: o, setCustomGroups: u } = G(
              s.groups
            );
            u(s["custom-groups"], a), e.value === null && o("shorthand"), e.loc.start.line !== e.loc.end.line && o("multiline");
            let y = {
              size: v(e.range),
              group: i(),
              node: e,
              name: a
            };
            return r.at(-1).push(y), r;
          },
          [[]]
        );
        for (let r of l)
          k(r, (e, a) => {
            let i = x(s.groups, e), o = x(s.groups, a);
            (i > o || i === o && I(S(e, a, s))) && t.report({
              messageId: "unexpectedJSXPropsOrder",
              data: {
                left: e.name,
                right: a.name
              },
              node: a.node,
              fix: (u) => {
                let y = {};
                for (let c of r) {
                  let d = x(s.groups, c);
                  d in y ? y[d] = w(
                    [...y[d], c],
                    s
                  ) : y[d] = [c];
                }
                let m = [];
                for (let c of Object.keys(y).sort(
                  (d, f) => Number(d) - Number(f)
                ))
                  m.push(...w(y[c], s));
                return L(
                  u,
                  r,
                  m,
                  t.sourceCode
                );
              }
            });
          });
      }
    }
  }
}), te = "sort-exports", we = O({
  name: te,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted exports"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [g.asc, g.desc],
            default: g.asc,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedExportsOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: g.asc
    }
  ],
  create: (t) => {
    let n = j(t.options.at(0), {
      type: p.alphabetical,
      order: g.asc,
      "ignore-case": !1
    }), s = [[]], l = (r) => {
      r.type === "ExportAllDeclaration" && r.exported === null ? s.push([]) : s.at(-1).push({
        size: v(r.range),
        name: r.source.value,
        node: r
      });
    };
    return {
      ExportAllDeclaration: l,
      ExportNamedDeclaration: (r) => {
        r.source !== null && l(r);
      },
      "Program:exit": () => {
        for (let r of s)
          k(r, (e, a) => {
            I(S(e, a, n)) && t.report({
              messageId: "unexpectedExportsOrder",
              data: {
                left: e.name,
                right: a.name
              },
              node: a.node,
              fix: (i) => L(
                i,
                r,
                w(r, n),
                t.sourceCode
              )
            });
          });
      }
    };
  }
}), re = "sort-imports", Se = O({
  name: re,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted imports"
    },
    fixable: "code",
    schema: [
      {
        id: "sort-imports",
        type: "object",
        properties: {
          "custom-groups": {
            type: "object",
            properties: {
              type: {
                type: "object"
              },
              value: {
                type: "object"
              }
            },
            additionalProperties: !1
          },
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [g.asc, g.desc],
            default: g.asc,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          },
          groups: {
            type: "array",
            default: []
          },
          "internal-pattern": {
            items: {
              type: "string"
            },
            type: "array"
          },
          "newlines-between": {
            enum: [
              "ignore",
              "always",
              "never"
              /* never */
            ],
            default: "always",
            type: "string"
          },
          "max-line-length": {
            type: "integer",
            minimum: 0,
            exclusiveMinimum: !0
          }
        },
        allOf: [
          { $ref: "#/definitions/max-line-length-requires-line-length-type" }
        ],
        additionalProperties: !1,
        dependencies: {
          "max-line-length": ["type"]
        },
        definitions: {
          "is-line-length": {
            properties: {
              type: { enum: [p["line-length"]], type: "string" }
            },
            required: ["type"],
            type: "object"
          },
          "max-line-length-requires-line-length-type": {
            anyOf: [
              {
                not: { required: ["max-line-length"], type: "object" },
                type: "object"
              },
              { $ref: "#/definitions/is-line-length" }
            ]
          }
        }
      }
    ],
    messages: {
      unexpectedImportsOrder: 'Expected "{{right}}" to come before "{{left}}"',
      missedSpacingBetweenImports: 'Missed spacing between "{{left}}" and "{{right}}" imports',
      extraSpacingBetweenImports: 'Extra spacing between "{{left}}" and "{{right}}" imports'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: g.asc
    }
  ],
  create: (t) => {
    let n = j(t.options.at(0), {
      "newlines-between": "always",
      "custom-groups": { type: {}, value: {} },
      "internal-pattern": ["~/**"],
      type: p.alphabetical,
      order: g.asc,
      "ignore-case": !1,
      groups: []
    }), s = !1;
    for (let o of n.groups)
      if (Array.isArray(o))
        for (let u of o)
          u === "unknown" && (s = !0);
      else
        o === "unknown" && (s = !0);
    s || (n.groups = [...n.groups, "unknown"]);
    let l = [], r = (o) => o.type === "ImportDeclaration" && o.specifiers.length === 0, e = (o) => {
      let u = (N) => [".less", ".scss", ".sass", ".styl", ".pcss", ".css", ".sss"].some(
        (P) => N.endsWith(P)
      ), y = (N) => [
        "./index.d.js",
        "./index.d.ts",
        "./index.js",
        "./index.ts",
        "./index",
        "./",
        "."
      ].includes(N), m = (N) => N.indexOf("..") === 0, c = (N) => N.indexOf("./") === 0, { getGroup: d, defineGroup: f, setCustomGroups: b } = G(n.groups), E = (N) => n["internal-pattern"].length && n["internal-pattern"].some(
        (P) => $(N.source.value, P, {
          nocomment: !0
        })
      ), h = (N) => {
        let P = [
          "bun",
          "bun:ffi",
          "bun:jsc",
          "bun:sqlite",
          "bun:test",
          "bun:wrap",
          "detect-libc",
          "undici",
          "ws"
        ];
        return de.includes(
          N.startsWith("node:") ? N.split("node:")[1] : N
        ) || P.includes(N);
      }, C = (N) => !(N.startsWith(".") || N.startsWith("/"));
      return o.importKind === "type" && (o.type === "ImportDeclaration" && (b(n["custom-groups"].type, o.source.value), y(o.source.value) && f("index-type"), c(o.source.value) && f("sibling-type"), m(o.source.value) && f("parent-type"), E(o) && f("internal-type"), h(o.source.value) && f("builtin-type"), C(o.source.value) && f("external-type")), f("type")), o.type === "ImportDeclaration" && (b(n["custom-groups"].value, o.source.value), r(o) && u(o.source.value) && f("side-effect-style"), r(o) && f("side-effect"), u(o.source.value) && f("style"), y(o.source.value) && f("index"), c(o.source.value) && f("sibling"), m(o.source.value) && f("parent"), E(o) && f("internal"), h(o.source.value) && f("builtin"), C(o.source.value) && f("external")), d();
    }, a = (o) => o.specifiers.length > 1, i = (o) => {
      let u;
      o.type === "ImportDeclaration" ? u = o.source.value : o.moduleReference.type === "TSExternalModuleReference" && o.moduleReference.expression.type === "Literal" ? u = `${o.moduleReference.expression.value}` : u = t.sourceCode.text.slice(...o.moduleReference.range), l.push({
        size: v(o.range),
        group: e(o),
        name: u,
        node: o,
        ...n.type === p["line-length"] && n["max-line-length"] && {
          hasMultipleImportDeclarations: a(
            o
          )
        }
      });
    };
    return {
      TSImportEqualsDeclaration: i,
      ImportDeclaration: i,
      "Program:exit": () => {
        var m;
        let o = (c, d) => !!t.sourceCode.getTokensBetween(
          c.node,
          V(d.node, t.sourceCode) || d.node,
          {
            includeComments: !0
          }
        ).length, u = (c, d) => {
          let f = [], b = {};
          for (let h of d) {
            let C = x(n.groups, h);
            C in b ? b[C] = w(
              [...b[C], h],
              n
            ) : b[C] = [h];
          }
          let E = Object.keys(b).sort((h, C) => Number(h) - Number(C)).reduce(
            (h, C) => [
              ...h,
              ...b[C]
            ],
            []
          );
          for (let h = 0, C = E.length; h < C; h++) {
            let N = E.at(h);
            if (f.push(
              c.replaceTextRange(
                T(d.at(h).node, t.sourceCode),
                t.sourceCode.text.slice(
                  ...T(N.node, t.sourceCode)
                )
              )
            ), n["newlines-between"] !== "ignore") {
              let P = E.at(h + 1);
              if (P) {
                let M = z(
                  t.sourceCode,
                  d.at(h),
                  d.at(h + 1)
                );
                (n["newlines-between"] === "always" && x(n.groups, N) === x(n.groups, P) && M !== 0 || n["newlines-between"] === "never" && M > 0) && f.push(
                  c.removeRange([
                    T(
                      d.at(h).node,
                      t.sourceCode
                    ).at(1),
                    T(
                      d.at(h + 1).node,
                      t.sourceCode
                    ).at(0) - 1
                  ])
                ), n["newlines-between"] === "always" && x(n.groups, N) !== x(n.groups, P) && M > 1 && f.push(
                  c.replaceTextRange(
                    [
                      T(
                        d.at(h).node,
                        t.sourceCode
                      ).at(1),
                      T(
                        d.at(h + 1).node,
                        t.sourceCode
                      ).at(0) - 1
                    ],
                    `
`
                  )
                ), n["newlines-between"] === "always" && x(n.groups, N) !== x(n.groups, P) && M === 0 && f.push(
                  c.insertTextAfterRange(
                    T(d.at(h).node, t.sourceCode),
                    `
`
                  )
                );
              }
            }
          }
          return f;
        }, y = [[]];
        for (let c of l) {
          let d = (m = y.at(-1)) == null ? void 0 : m.at(-1);
          d && o(d, c) ? y.push([c]) : y.at(-1).push(c);
        }
        for (let c of y)
          k(c, (d, f) => {
            let b = x(n.groups, d), E = x(n.groups, f), h = z(
              t.sourceCode,
              d,
              f
            );
            !(r(d.node) && r(f.node)) && !o(d, f) && (b > E || b === E && I(S(d, f, n))) && t.report({
              messageId: "unexpectedImportsOrder",
              data: {
                left: d.name,
                right: f.name
              },
              node: f.node,
              fix: (C) => u(C, c)
            }), n["newlines-between"] === "never" && h > 0 && t.report({
              messageId: "extraSpacingBetweenImports",
              data: {
                left: d.name,
                right: f.name
              },
              node: f.node,
              fix: (C) => u(C, c)
            }), n["newlines-between"] === "always" && (b < E && h === 0 ? t.report({
              messageId: "missedSpacingBetweenImports",
              data: {
                left: d.name,
                right: f.name
              },
              node: f.node,
              fix: (C) => u(C, c)
            }) : (h > 1 || b === E && h > 0) && t.report({
              messageId: "extraSpacingBetweenImports",
              data: {
                left: d.name,
                right: f.name
              },
              node: f.node,
              fix: (C) => u(C, c)
            }));
          });
      }
    };
  }
}), se = "sort-objects", Ae = O({
  name: se,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted objects"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          "custom-groups": {
            type: "object"
          },
          "partition-by-comment": {
            type: ["boolean", "string", "array"],
            default: !1
          },
          "partition-by-new-line": {
            type: "boolean",
            default: !1
          },
          "styled-components": {
            type: "boolean",
            default: !0
          },
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [g.asc, g.desc],
            default: g.asc,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          },
          groups: {
            type: "array"
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedObjectsOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: g.asc
    }
  ],
  create: (t) => {
    let n = (s) => {
      if (s.properties.length > 1) {
        let l = j(t.options.at(0), {
          "partition-by-new-line": !1,
          "partition-by-comment": !1,
          type: p.alphabetical,
          "styled-components": !0,
          "ignore-case": !1,
          order: g.asc,
          "custom-groups": {},
          groups: []
        }), r = (i) => i.type === "Identifier" && i.name === "styled", e = (i) => i !== void 0 && i.type === "CallExpression" && (i.callee.type === "MemberExpression" && r(i.callee.object) || i.callee.type === "CallExpression" && r(i.callee.callee));
        if (!l["styled-components"] && (e(s.parent) || s.parent.type === "ArrowFunctionExpression" && e(s.parent.parent)))
          return;
        let a = (i) => i.reduce(
          (o, u) => {
            var N;
            if (u.type === "SpreadElement" || u.type === "RestElement")
              return o.push([]), o;
            let y = V(u, t.sourceCode), m = (N = o.at(-1)) == null ? void 0 : N.at(-1);
            l["partition-by-comment"] && y && ie(
              l["partition-by-comment"],
              y.value
            ) && o.push([]);
            let c, d = "ignore", f = [], { getGroup: b, setCustomGroups: E } = G(l.groups);
            u.key.type === "Identifier" ? { name: c } = u.key : u.key.type === "Literal" ? c = `${u.key.value}` : c = t.sourceCode.text.slice(...u.key.range);
            let h = {
              size: v(u.range),
              node: u,
              name: c
            };
            l["partition-by-new-line"] && m && z(t.sourceCode, m, h) && o.push([]), u.value.type === "AssignmentPattern" && ((M) => {
              M.right.type === "Identifier" && f.push(M.right.name);
              let le = (R) => {
                let D = [];
                switch (R.type) {
                  case "ArrowFunctionExpression":
                    D.push(R.body);
                    break;
                  case "ConditionalExpression":
                    D.push(R.consequent, R.alternate);
                    break;
                  case "LogicalExpression":
                  case "BinaryExpression":
                    D.push(R.left, R.right);
                    break;
                  case "CallExpression":
                    D.push(...R.arguments);
                    break;
                }
                D.forEach((U) => {
                  U.type === "Identifier" && f.push(U.name), (U.type === "BinaryExpression" || U.type === "ConditionalExpression") && le(U);
                });
              };
              switch (M.right.type) {
                case "ArrowFunctionExpression":
                case "ConditionalExpression":
                case "LogicalExpression":
                case "BinaryExpression":
                case "CallExpression":
                  le(M.right);
                  break;
              }
            })(u.value), E(l["custom-groups"], c);
            let C = {
              ...h,
              group: b(),
              dependencies: f,
              position: d
            };
            return o.at(-1).push(C), o;
          },
          [[]]
        );
        for (let i of a(s.properties))
          k(i, (o, u) => {
            let y = x(l.groups, o), m = x(l.groups, u);
            if (y > m || y === m && I(S(o, u, l))) {
              let c = (d) => {
                let f = {};
                for (let E of i) {
                  let h = x(l.groups, E);
                  h in f ? f[h] = w(
                    [...f[h], E],
                    l
                  ) : f[h] = [E];
                }
                let b = [];
                for (let E of Object.keys(f).sort(
                  (h, C) => Number(h) - Number(C)
                ))
                  b.push(...w(f[E], l));
                return L(
                  d,
                  i,
                  b,
                  t.sourceCode,
                  {
                    partitionComment: l["partition-by-comment"]
                  }
                );
              };
              t.report({
                messageId: "unexpectedObjectsOrder",
                data: {
                  left: A(o.name),
                  right: A(u.name)
                },
                node: u.node,
                fix: c
              });
            }
          });
      }
    };
    return {
      ObjectExpression: n,
      ObjectPattern: n
    };
  }
}), ae = "sort-classes", Oe = O({
  name: ae,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted classes"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          },
          order: {
            enum: [g.asc, g.desc],
            default: g.asc,
            type: "string"
          },
          groups: {
            type: "array",
            default: []
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedClassesOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: g.asc
    }
  ],
  create: (t) => ({
    ClassBody: (n) => {
      if (n.body.length > 1) {
        let s = j(t.options.at(0), {
          type: p.alphabetical,
          order: g.asc,
          "ignore-case": !1,
          groups: ["property", "constructor", "method", "unknown"]
        }), l = n.body.map((r) => {
          var u;
          let e, { getGroup: a, defineGroup: i } = G(s.groups);
          r.type === "StaticBlock" ? e = "static" : r.type === "TSIndexSignature" ? e = t.sourceCode.text.slice(
            r.range.at(0),
            ((u = r.typeAnnotation) == null ? void 0 : u.range.at(0)) ?? r.range.at(1)
          ) : r.key.type === "Identifier" ? { name: e } = r.key : e = t.sourceCode.text.slice(...r.key.range);
          let o = e.startsWith("_") || e.startsWith("#");
          if (r.type === "MethodDefinition") {
            r.kind === "constructor" && i("constructor");
            let y = r.accessibility === "private" || o, m = r.static;
            y && m && i("static-private-method"), y && i("private-method"), m && i("static-method"), r.kind === "get" && i("get-method"), r.kind === "set" && i("set-method"), i("method");
          } else
            r.type === "TSIndexSignature" ? i("index-signature") : r.type === "PropertyDefinition" && ((r.accessibility === "private" || o) && i("private-property"), r.static && i("static-property"), i("property"));
          return {
            size: v(r.range),
            group: a(),
            node: r,
            name: e
          };
        });
        k(l, (r, e) => {
          let a = x(s.groups, r), i = x(s.groups, e);
          r.name !== e.name && (a > i || a === i && I(S(r, e, s))) && t.report({
            messageId: "unexpectedClassesOrder",
            data: {
              left: A(r.name),
              right: A(e.name)
            },
            node: e.node,
            fix: (o) => {
              let u = [], y = l.reduce(
                (c, d) => {
                  let f = x(s.groups, d);
                  return f in c ? c[f] = w(
                    [...c[f], d],
                    s
                  ) : c[f] = [d], c;
                },
                {}
              ), m = Object.keys(y).sort((c, d) => Number(c) - Number(d)).reduce(
                (c, d) => [
                  ...c,
                  ...y[d]
                ],
                []
              );
              for (let c = 0, d = m.length; c < d; c++)
                u.push(
                  o.replaceTextRange(
                    T(l.at(c).node, t.sourceCode),
                    t.sourceCode.text.slice(
                      ...T(
                        m.at(c).node,
                        t.sourceCode
                      )
                    )
                  )
                );
              return u;
            }
          });
        });
      }
    }
  })
}), oe = "sort-enums", ve = O({
  name: oe,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted TypeScript enums"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          },
          order: {
            enum: [g.asc, g.desc],
            default: g.asc,
            type: "string"
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedEnumsOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: g.asc
    }
  ],
  create: (t) => ({
    TSEnumDeclaration: (n) => {
      if (n.members.length > 1 && n.members.every(({ initializer: s }) => s)) {
        let s = j(t.options.at(0), {
          type: p.alphabetical,
          order: g.asc,
          "ignore-case": !1
        }), l = n.members.map((r) => ({
          name: r.id.type === "Literal" ? `${r.id.value}` : `${t.sourceCode.text.slice(...r.id.range)}`,
          size: v(r.range),
          node: r
        }));
        k(l, (r, e) => {
          I(S(r, e, s)) && t.report({
            messageId: "unexpectedEnumsOrder",
            data: {
              left: A(r.name),
              right: A(e.name)
            },
            node: e.node,
            fix: (a) => L(
              a,
              l,
              w(l, s),
              t.sourceCode
            )
          });
        });
      }
    }
  })
}), ne = "sort-maps", Ie = O({
  name: ne,
  meta: {
    type: "suggestion",
    docs: {
      description: "enforce sorted Map elements"
    },
    fixable: "code",
    schema: [
      {
        type: "object",
        properties: {
          type: {
            enum: [
              p.alphabetical,
              p.natural,
              p["line-length"]
            ],
            default: p.alphabetical,
            type: "string"
          },
          order: {
            enum: [g.asc, g.desc],
            default: g.asc,
            type: "string"
          },
          "ignore-case": {
            type: "boolean",
            default: !1
          }
        },
        additionalProperties: !1
      }
    ],
    messages: {
      unexpectedMapElementsOrder: 'Expected "{{right}}" to come before "{{left}}"'
    }
  },
  defaultOptions: [
    {
      type: p.alphabetical,
      order: g.asc
    }
  ],
  create: (t) => ({
    NewExpression: (n) => {
      if (n.callee.type === "Identifier" && n.callee.name === "Map" && n.arguments.length && n.arguments[0].type === "ArrayExpression") {
        let [{ elements: s }] = n.arguments;
        if (s.length > 1) {
          let l = j(t.options.at(0), {
            type: p.alphabetical,
            "ignore-case": !1,
            order: g.asc
          }), r = s.reduce(
            (e, a) => (a === null || a.type === "SpreadElement" ? e.push([]) : e.at(-1).push(a), e),
            [[]]
          );
          for (let e of r) {
            let a = e.map((i) => {
              let o;
              if (i.type === "ArrayExpression") {
                let [u] = i.elements;
                u ? u.type === "Literal" ? o = u.raw : o = t.sourceCode.text.slice(...u.range) : o = `${u}`;
              } else
                o = t.sourceCode.text.slice(...i.range);
              return {
                size: v(i.range),
                node: i,
                name: o
              };
            });
            k(a, (i, o) => {
              I(S(i, o, l)) && t.report({
                messageId: "unexpectedMapElementsOrder",
                data: {
                  left: A(i.name),
                  right: A(o.name)
                },
                node: o.node,
                fix: (u) => L(
                  u,
                  a,
                  w(a, l),
                  t.sourceCode
                )
              });
            });
          }
        }
      }
    }
  })
}), je = "eslint-plugin-perfectionist";
let W = (t) => {
  let n = {
    [re]: [
      "error",
      {
        groups: [
          "type",
          ["builtin", "external"],
          "internal-type",
          "internal",
          ["parent-type", "sibling-type", "index-type"],
          ["parent", "sibling", "index"],
          "object",
          "unknown"
        ],
        "custom-groups": {
          value: {},
          type: {}
        },
        "newlines-between": "always",
        "internal-pattern": ["~/**"]
      }
    ],
    [ae]: [
      "error",
      {
        groups: [
          "index-signature",
          "static-property",
          "private-property",
          "property",
          "constructor",
          "static-method",
          "private-method",
          "method",
          ["get-method", "set-method"],
          "unknown"
        ]
      }
    ],
    [se]: [
      "error",
      {
        "partition-by-comment": !1
      }
    ],
    [q]: [
      "error",
      {
        "spread-last": !0
      }
    ],
    [J]: ["error"],
    [X]: ["error"],
    [K]: ["error"],
    [H]: ["error"],
    [Q]: ["error"],
    [Y]: ["error"],
    [Z]: ["error"],
    [F]: ["error"],
    [ee]: ["error"],
    [te]: ["error"],
    [oe]: ["error"],
    [ne]: ["error"]
  };
  return {
    rules: Object.fromEntries(
      Object.entries(n).map(([s, [l, r = {}]]) => [
        `perfectionist/${s}`,
        [l, Object.assign(r, t)]
      ])
    ),
    plugins: ["perfectionist"]
  };
};
const Ge = {
  rules: {
    [q]: ye,
    [X]: ge,
    [ae]: Oe,
    [oe]: ve,
    [te]: we,
    [re]: Se,
    [F]: Ce,
    [ee]: Ne,
    [ne]: Ie,
    [H]: he,
    [Q]: be,
    [Y]: xe,
    [se]: Ae,
    [J]: fe,
    [Z]: Ee,
    [K]: me
  },
  configs: {
    "recommended-alphabetical": W({
      type: p.alphabetical,
      order: g.asc,
      "ignore-case": !1
    }),
    "recommended-natural": W({
      type: p.natural,
      order: g.asc,
      "ignore-case": !1
    }),
    "recommended-line-length": W({
      type: p["line-length"],
      order: g.desc
    })
  },
  name: je
};
export {
  Ge as default
};
